//usingfBNeBuŖOԂ̎QƂȒPɂ܂B
using System;
using System.Drawing;
using System.Windows.Forms;
using Wakaba;

namespace Game
{
    class Game
    {
        private const int STAR_MAX  = 50;       //̐
        private const int STAR_SPEED = 4;       //̈ړx
        private const int STAR_ROLL_SPEED = 8;  //̉]x

        public struct StarPos{
            public int X;      //XW
            public int Y;      //YW
            public int AddX;   //Xړ
            public int AddY;   //Yړ
        }
        
        //IuWFNgϐ錾܂B
        private static Helper w;

        [STAThread]
        static void Main(string[] args)
        {
            try
            {
                int intRoll = 0;
                StarPos[] Position = new StarPos[STAR_MAX];

                //IuWFNgϐCX^X܂B
                w = new Helper();

                //twp[܂B
                w.Initialize();

                //wi쐬܂B
                w.SpriteCreate("wi", MyGame1.Properties.Resources.wall, Helper.TransparentColor.None);
                w.SpritePosition("wi", STAR_MAX + 1, 0, 0);
                w.SpriteHitAdd("wi", "Ǐ", 0, -32, 640, 32);
                w.SpriteHitAdd("wi", "ǉE", 640, 0, 32, 480);
                w.SpriteHitAdd("wi", "ǉ", 0, 480, 640, 32);
                w.SpriteHitAdd("wi", "Ǎ", -32, 0, 32, 480);
                w.SpriteShow("wi");

                //쐬܂B
                w.SpriteCreate("", MyGame1.Properties.Resources.star, Helper.TransparentColor.PictureTopLeft);
                for (int i = 0; i < STAR_MAX; i++)
                {
                    w.SpriteCreate("" + i, "", 0, 0, 64, 64);
                    w.SpriteHitAdd("" + i, "萯", 0, 0, 64, 64);

                    Random objRnd = new Random(i);
                    Position[i].X = objRnd.Next(0, 640 - 64);
                    Position[i].Y = objRnd.Next(0, 480 - 64);
                    Position[i].AddX = STAR_SPEED;
                    Position[i].AddY = STAR_SPEED;

                    w.SpritePosition("" + i, i, Position[i].X, Position[i].Y);
                    w.SpriteTransparent("" + i, 128);

                    w.SpriteShow("" + i);
                }

                //EBhE܂ŉʂXV܂B
                do
                {
                    for (int j = 0; j < STAR_MAX; j++)
                    {

                        foreach (Helper.HitName objWallName in w.SpriteHitList("" + j))
                        {

                            switch (objWallName.AreaName)
                            {
                                case "Ǐ":
                                    Position[j].AddY = STAR_SPEED;
                                    break;
                                case "ǉE":
                                    Position[j].AddX = -STAR_SPEED;
                                    break;
                                case "ǉ":
                                    Position[j].AddY = -STAR_SPEED;
                                    break;
                                case "Ǎ":
                                    Position[j].AddX = STAR_SPEED;
                                    break;
                            }

                        }

                        Position[j].X += Position[j].AddX;
                        Position[j].Y += Position[j].AddY;

                        w.SpriteRotation("" + j, (short)intRoll);
                        w.SpritePosition("" + j, j, Position[j].X, Position[j].Y);
                    }

                    if (intRoll > 360)
                    {
                        intRoll = 0;
                    }
                    else
                    {
                        intRoll += STAR_ROLL_SPEED;
                    }

                    w.ScreenRefresh(true);

                } while (!w.WindowClosing);

            }
            catch (Exception ex)
            {
                //twp[̃G[bZ[W\܂B
                MessageBox.Show(ex.Message + ex.StackTrace);
            }

            //twp[̃IuWFNgj܂B
            w.Dispose();
        }
    }
}